#ifndef __WEBOTS_COMMUNICATION_SERVER_H__
#define __WEBOTS_COMMUNICATION_SERVER_H__

#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

#include <string>
#include <vector>
#include <libwebots/communication/client.hh>
#include <libwebots/communication/socket.hh>
#include <libwebots/communication/message.pb.h>
#include <libwebots/communication/handlers.hh>

namespace libwebots
{
namespace communication
{
	class Server : public Socket, public Handlers
	{
		static Server *s_instance;

		std::string d_filename;
		std::vector<Client *> d_clients;
		Client *d_currentClient;

		bool d_async;

		public:
			static Server &Initialize(bool async = false);
			static Server &Instance();

			static void Finalize();

			~Server();

			bool Send(Message const &message);
			bool Receive(Client *&client, Message &message);

			virtual void Close();
			void Accept();
		private:
			Server(bool async);

			std::string GenerateSocketFileName();
	};
}
}

#endif /* __WEBOTS_COMMUNICATION_SERVER_H__ */

