#ifndef __LIBWEBOTS_COMMUNICATION_SOCKET_H__
#define __LIBWEBOTS_COMMUNICATION_SOCKET_H__

#include <string>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>

namespace libwebots
{
namespace communication
{
	class Socket
	{
		int d_fd;
		struct addrinfo *d_info;

		public:
			Socket();
			Socket(int fd);
			Socket(std::string const &filename);

			virtual ~Socket();

			int Fd() const;
			virtual void Close();

			struct addrinfo const *AddressInfo() const;

			operator bool() const;

			void Open(int fd);
			void Open(std::string const &filename);

			void SetNonBlocking(bool val = true);
		private:
			struct addrinfo *CreateAddressInfo(std::string const &filename);
	};
}
}

#endif /* __LIBWEBOTS_COMMUNICATION_SOCKET_H__ */

