/**
 * \file baseof.hh
 *
 *  \date Mar 8, 2011
 *  \author Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_BASEOF_HH_
#define __LIBWEBOTS_PLUGIN_BASEOF_HH_

namespace libwebots
{
namespace plugin
{

	/**
	 * Template class, such as is_base_of<B,D>::value == true
	 * if B is a base of D (D could be casted to a B)
	 */
	template<class B, class D>
	class is_base_of {
	        typedef char yes;
	        struct no{char dummy[2];};
	        static yes test(const B&); // will be chosen if B is base of D
	        static no  test(...);      // will be chosen otherwise
	        static const D& helper();
		public :
	        static const bool value =
	            sizeof(test(helper())) == sizeof(yes);
	        // true if test(const B&) was chosen
	};
}
}

#endif // __LIBWEBOTS_PLUGIN_BASEOF_HH_
