#ifndef __LIBWEBOTS_PLUGIN_MODULES_INTERFACES_INTERFACE_H__
#define __LIBWEBOTS_PLUGIN_MODULES_INTERFACES_INTERFACE_H__

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace interfaces
{
	/**
	 * @brief Module interface
	 *
	 * The Interface class is a base template class
	 * for default interface implementations. This class can be
	 * specialized by a module to provide a more specific interface
	 * by which other modules can interact with this module.
	 *
	 * @see Module::GetInterface<ModuleName>()
	 *
	 **/
	template <typename ModuleName>
	class Interface
	{
		public:
			Interface(ModuleName &);
			~Interface();
	};

	/**
	 * @brief Default constructor
	 * @param module reference to the interfaced module
	 *
	 * Create a new interface for the given module
	 *
	 **/
	template <typename ModuleName>
	Interface<ModuleName>::Interface(ModuleName &)
	{
	}

	template <typename ModuleName>
	Interface<ModuleName>::~Interface()
	{
	}
}
}
}
}

#endif /* __LIBWEBOTS_PLUGIN_MODULES_INTERFACES_INTERFACE_H__ */
