#ifndef __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_CONSTRAINT_H__
#define __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_CONSTRAINT_H__

#include <libwebots/communication/messages.hh>
#include <string>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace messages
{
namespace builders
{
	class Constraint
	{
		public:
			static communication::Message FixInWorld(std::string const &body,
			                                         bool               monitor = false);

			static communication::Message FixInAxis(std::string const &body,
			                                        bool               monitor = false);

			static communication::Message FixInAxis(std::string const &body,
			                                        double             axis[3],
			                                        bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             rotationMinStop,
			                                         double             rotationMaxStop,
			                                         bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         bool               canRotate = false,
			                                         bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             axis1[3],
			                                         bool               canRotate = false,
			                                         bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             axis1[3],
			                                         double             rotationMinStop,
			                                         double             rotationMaxStop,
			                                         bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             axis1[3],
			                                         double             axis2[3],
			                                         bool               canRotate = false,
			                                         bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             axis1[3],
			                                         double             axis2[3],
			                                         double             rotationMinStop,
			                                         double             rotationMaxStop,
			                                         bool               monitor = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             axis1[3],
			                                         double             axis2[3],
			                                         double             disable1Timeout,
			                                         double             disable2Timeout,
			                                         double             disableRotationTimeout,
			                                         bool               destroy1OnTimeout,
			                                         bool               destroy2OnTimeout,
			                                         bool               destroyRotationOnTimeout,
			                                         bool               canRotate = false,
			                                         bool               monitor1 = false,
			                                         bool               monitor2 = false,
			                                         bool               monitorRotation = false);

			static communication::Message FixInPlane(std::string const &body,
			                                         double             axis1[3],
			                                         double             axis2[3],
			                                         double             disable1Timeout,
			                                         double             disable2Timeout,
			                                         double             disableRotationTimeout,
			                                         bool               destroy1OnTimeout,
			                                         bool               destroy2OnTimeout,
			                                         bool               destroyRotationOnTimeout,
			                                         double             rotationMinStop,
			                                         double             rotationMaxStop,
			                                         bool               monitor1 = false,
			                                         bool               monitor2 = false,
			                                         bool               monitorRotation = false);

			static communication::Message Destroy(std::string const &body);
			static communication::Message Enable(std::string const &body, bool enable);

			static communication::Message SetVelocity(std::string const &body, double velocity);
			static communication::Message MonitorJoint(std::string const &body);
	};
}
}
}
}
}

#endif /* __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_CONSTRAINT_H__ */

