#include "contactbuilder.hh"
#include "contact.pb.h"

using namespace libwebots::plugin::modules::messages;
using namespace libwebots::communication;
using namespace std;

Message
builders::Contact::Monitor(string const &body)
{
	contact::Contact cont;

	cont.set_body1(body);
	cont.set_monitor(true);

	return Messages::Create(contact::contact, cont);
}

Message
builders::Contact::Monitor(string const &body1,
                           string const &body2)
{
	contact::Contact cont;

	cont.set_body1(body1);
	cont.set_body2(body2);

	cont.set_monitor(true);

	return Messages::Create(contact::contact, cont);
}

Message
builders::Contact::Monitor()
{
	contact::Contact cont;

	cont.set_monitor(true);

	return Messages::Create(contact::contact, cont);
}

Message
builders::Contact::Custom(string const &body,
                          double        bounce,
                          double        bounceVelocity,
                          double        coulombFriction,
                          double        forceDependentSlip,
                          bool          draw)
{
	contact::Contact cont;

	cont.set_body1(body);

	cont.set_bounce(bounce);
	cont.set_bouncevelocity(bounceVelocity);
	cont.set_coulombfriction(coulombFriction);
	cont.set_forcedependentslip(forceDependentSlip);

	cont.set_draw(draw);

	return Messages::Create(contact::contact, cont);
}

Message
builders::Contact::Custom(string const &body,
                       double        bounce,
                       double        bounceVelocity,
                       double        coulombFriction,
                       double        forceDependentSlip,
                       double        softERP,
                       double        softCFM,
                       bool          draw)
{
	contact::Contact cont;

	cont.set_body1(body);

	cont.set_bounce(bounce);
	cont.set_bouncevelocity(bounceVelocity);
	cont.set_coulombfriction(coulombFriction);
	cont.set_forcedependentslip(forceDependentSlip);
	cont.set_softerp(softERP);
	cont.set_softcfm(softCFM);

	cont.set_draw(draw);

	return Messages::Create(contact::contact, cont);
}

Message
builders::Contact::Custom(string const &body1,
                          string const &body2,
                          double        bounce,
                          double        bounceVelocity,
                          double        coulombFriction,
                          double        forceDependentSlip,
                          bool          draw)
{
	contact::Contact cont;

	cont.set_body1(body1);
	cont.set_body2(body2);

	cont.set_bounce(bounce);
	cont.set_bouncevelocity(bounceVelocity);
	cont.set_coulombfriction(coulombFriction);
	cont.set_forcedependentslip(forceDependentSlip);

	cont.set_draw(draw);

	return Messages::Create(contact::contact, cont);
}

Message
builders::Contact::Custom(string const &body1,
                          string const &body2,
                          double        bounce,
                          double        bounceVelocity,
                          double        coulombFriction,
                          double        forceDependentSlip,
                          double        softERP,
                          double        softCFM,
                          bool          draw)
{
	contact::Contact cont;

	cont.set_body1(body1);
	cont.set_body2(body2);

	cont.set_bounce(bounce);
	cont.set_bouncevelocity(bounceVelocity);
	cont.set_coulombfriction(coulombFriction);
	cont.set_forcedependentslip(forceDependentSlip);
	cont.set_softerp(softERP);
	cont.set_softcfm(softCFM);

	cont.set_draw(draw);

	return Messages::Create(contact::contact, cont);
}
