#ifndef __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_CONTACT_H__
#define __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_CONTACT_H__

#include <libwebots/communication/messages.hh>
#include <string>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace messages
{
namespace builders
{
	class Contact
	{
		public:
			static communication::Message Monitor(std::string const &body);
			static communication::Message Monitor(std::string const &body1,
			                                      std::string const &body2);

			static communication::Message Monitor();

			static communication::Message Custom(std::string const &body,
			                                     double             bounce,
			                                     double             bounceVelocity,
			                                     double             coulombFriction,
			                                     double             forceDependentSlip,
			                                     double             softERP,
			                                     double             softCFM,
			                                     bool               draw = true);

			static communication::Message Custom(std::string const &body,
			                                     double             bounce,
			                                     double             bounceVelocity,
			                                     double             coulombFriction,
			                                     double             forceDependentSlip,
			                                     bool               draw = true);

			static communication::Message Custom(std::string const &body1,
			                                     std::string const &body2,
			                                     double             bounce,
			                                     double             bounceVelocity,
			                                     double             coulombFriction,
			                                     double             forceDependentSlip,
			                                     double             softERP,
			                                     double             softCFM,
			                                     bool               draw = true);

			static communication::Message Custom(std::string const &body1,
			                                     std::string const &body2,
			                                     double             bounce,
			                                     double             bounceVelocity,
			                                     double             coulombFriction,
			                                     double             forceDependentSlip,
			                                     bool               draw = true);
	};
}
}
}
}
}

#endif /* __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_CONTACT_H__ */

