/**
 * \file slider.cc
 *
 *  \date Feb 8, 2013
 *  \author Alexandre Tuleu
 */

#include "slider.hh"


using namespace libwebots::plugin::modules::jointmanager;
using namespace libwebots::plugin::modules::messages::jointmanager;


void Slider::SetAnchor(const dVector3 )
{
}



void Slider::SetAxis(const dVector3 worldAxis)
{
	if(!*this) { return; }
	dJointSetSliderAxis(Id(),
	                    worldAxis[0],
	                    worldAxis[1],
	                    worldAxis[2]);
}



std::auto_ptr<Joint> Slider::Clone() const
{
	return std::auto_ptr<Joint>(new Slider(*this));
}


unsigned int Slider::Dimension() const{
	return 1;
}


void Slider::SetParameter(int parameter, double value,unsigned int )
{
	if(!*this) { return; }
	dJointSetSliderParam(Id(),parameter,value);

}



void Slider::AddEffort(const Eigen::Vector3d & value)
{
	if(!*this) { return; }
	dJointAddSliderForce(Id(),value.x());
}



void Slider::ComputeCoordinateAndRate(double)
{
	if(!*this) { return; }
	GetCoordinate()[0] = dJointGetSliderPosition(Id());
	GetCoordinateRate()[0] = dJointGetSliderPositionRate(Id());

}



dJointID Slider::CreatePrimpl(dWorldID world, dJointGroupID group)
{
	if(*this) { return 0; }
	return dJointCreateSlider(world,group);
}

void Slider::Draw(double ){}


