/**
 * \file slider.hh
 *
 *  \date Feb 8, 2013
 *  \autor Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_MODULES_JOINTCREATOR_JOINT_SLIDER_HH_
#define __LIBWEBOTS_PLUGIN_MODULES_JOINTCREATOR_JOINT_SLIDER_HH_


#include <libwebots/plugin/modules/jointmanager/joint.hh>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace jointmanager
{

	class Slider : public Joint
	{
	public :
		virtual unsigned int Dimension() const;
		virtual void SetAnchor(const dVector3 worldPosition);
		virtual void SetAxis(const dVector3 worldAxis);
		virtual std::auto_ptr<Joint> Clone() const;
		virtual void SetParameter(int parameter,
		                          double value,
		                          unsigned int dimension);
		virtual void AddEffort(const Eigen::Vector3d & value);
		virtual void ComputeCoordinateAndRate(double);
		virtual dJointID CreatePrimpl(dWorldID world, dJointGroupID group);
		virtual void Draw(double size);

	};

} //namespace jointmanager
} //namespace modules
} //namespace plugin
} //namespace libwebots


#endif //__LIBWEBOTS_PLUGIN_MODULES_JOINTCREATOR_JOINT_SLIDER_HH_
