/**
 * \file profile.hh
 *
 *  \date Mar 2, 2011
 *  \author Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_MODULES_PUSH_PROFILE_HH__
#define __LIBWEBOTS_PLUGIN_MODULES_PUSH_PROFILE_HH__

#include <memory>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace push
{
	/**
	 * A class that specify a mapping from [0:1] to [0:1].
	 * 0 is the start of the perturbation
	 * 1 is the end of the perturbation.
	 * the result is a factor of the target value of the push.
	 */
	class Profile
	{
		public:
			Profile();
			virtual ~Profile();

			virtual std::auto_ptr<Profile> Clone() const = 0;
			double Value(double ratioDone);
		protected:
			virtual double ComputeValue(double ratioDone) = 0;
	};
}
}
}
}

#endif // __LIBWEBOTS_PLUGIN_MODULES_PUSH_PROFILE_HH__
