/**
 * \file profiles.hh
 *
 *  \date Mar 2, 2011
 *  \author Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_MODULES_PUSH_PROFILES_HH_
#define __LIBWEBOTS_PLUGIN_MODULES_PUSH_PROFILES_HH_

#include <libwebots/plugin/modules/push/profile.hh>
#include <libwebots/plugin/modules/push/push.hh>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace push
{
	class StepProfile : public Profile
	{
		public:
			StepProfile();
			virtual ~StepProfile();

			virtual std::auto_ptr<Profile> Clone() const;

		protected:
			double ComputeValue(double value);
	};

	class LinearProfile : public Profile
	{
		public:
			LinearProfile();
			virtual ~LinearProfile();

			virtual std::auto_ptr<Profile> Clone() const;

		protected:
			double ComputeValue(double value);
	};

	class QuadraticProfile : public Profile
	{
		public:
			QuadraticProfile();
			virtual ~QuadraticProfile();

			virtual std::auto_ptr<Profile> Clone() const;

		protected:
			double ComputeValue(double value);
	};
}
}
}
}

#endif // __LIBWEBOTS_PLUGIN_MODULES_PUSH_PROFILES_HH_
