/**
 * \file pushbuilder.cc
 *
 *  \date Mar 3, 2011
 *  \author Alexandre Tuleu
 */

#include "pushbuilder.hh"

using namespace libwebots::plugin::modules::messages;
using namespace libwebots::communication;

Message
builders::Push::PushBody(std::string const &body,
                         const double *force,
                         double duration,
                         const push::Profile::Values profile)
{
	push::Push push;

	push.set_body(body);

	push.mutable_force()->set_x(force[0]);
	push.mutable_force()->set_y(force[1]);
	push.mutable_force()->set_z(force[2]);
	push.mutable_force()->set_tx(force[3]);
	push.mutable_force()->set_ty(force[4]);
	push.mutable_force()->set_tz(force[5]);

	push.set_profile(profile);

	push.set_duration(duration);

	return Messages::Create(push::push, push);
}
