/**
 * \file pushbuilder.hh
 *
 *  \date Mar 3, 2011
 *  \author Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_PUSH_HH_
#define __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_PUSH_HH_

#include <libwebots/communication/messages.hh>
#include <libwebots/plugin/modules/push/push.pb.h>
#include <string>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace messages
{
namespace builders
{
	class Push
	{
		public:
			/**
			 * Creates a message that requets a body to be pushed in the world.
			 * @param body The DEF name of the body to push.
			 * @param force the 6 axis force to apply, in world coordinates.
			 * @param duration the duration of the perturbation in seconds
			 * @param profile the push::Profile to use.
			 * @return the well formatted communication::Message.
			 */
			static communication::Message PushBody(std::string const &body,
			                                       const double *force,
			                                       double duration,
			                                       const push::Profile::Values profile = push::Profile::Linear);
	};
}
}
}
}
}

#endif // __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_PUSH_HH_
