#ifndef __LIBWEBOTS_PLUGIN_MODULES_SNAP_H__
#define __LIBWEBOTS_PLUGIN_MODULES_SNAP_H__

#include <libwebots/plugin/module.hh>
#include <libwebots/plugin/modules/snap/snap.pb.h>
#include <libwebots/plugin/modules/debug/debug.hh>
#include <libwebots/plugin/body.hh>

#include <Eigen/Core>
#include <map>

namespace libwebots
{
namespace plugin
{
namespace modules
{
	class Snap : public Module , public interfaces::Debugable
	{
		public:
			Snap(MapByTypeID const &dependencies);
		private:
			void ShortestDistance(Body const &body,
			                      Eigen::Vector3d const &point,
			                      Eigen::Vector3d const &normal,
			                      Eigen::Vector3d &mindist,
			                      double &minlen);

			void ShortestDistance(dGeomID geom,
			                      Eigen::Vector3d const &point,
			                      Eigen::Vector3d const &normal,
			                      Eigen::Vector3d &mindist,
			                      double &minlen);

			void ShortestDistance(Eigen::Vector3d const &pt,
			                      Eigen::Vector3d const &point,
			                      Eigen::Vector3d const &normal,
			                      Eigen::Vector3d &mindist,
			                      double &minlen);

			void Handler(messages::snap::Snap const &message);
			void Handler(messages::snap::Plane const &message);
	};
}
}
}

#endif /* __LIBWEBOTS_PLUGIN_MODULES_SNAP_H__ */
