#include "snapbuilder.hh"

#include "snap.pb.h"

using namespace libwebots::plugin::modules::messages;
using namespace libwebots::plugin::modules::messages::snap;
using namespace libwebots::communication;

Message
builders::Snap::Plane(std::string const &body,
                      double             point[3],
                      double             normal[3],
                      double             margin,
                      bool               closestchild)
{
	snap::Snap sn;

	sn.set_action(snap::Action::Plane);

	snap::Plane &msg = *sn.mutable_plane();

	msg.set_body(body);

	for (size_t i = 0; i < 3; ++i)
	{
		msg.add_point(point[i]);
		msg.add_normal(normal[i]);
	}

	msg.set_closestchild(closestchild);
	msg.set_margin(margin);

	return Messages::Create(messages::snap::snap, sn);
}

Message
builders::Snap::Plane(std::string const &body,
                      double             p1,
                      double             p2,
                      double             p3,
                      double             n1,
                      double             n2,
                      double             n3,
                      double             margin,
                      bool               closestchild)
{
	double point[3] = {p1, p2, p3};
	double normal[3] = {n1, n2, n3};

	return Plane(body, point, normal, margin, closestchild);
}
