#ifndef __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_SNAP_H__
#define __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_SNAP_H__

#include <libwebots/communication/messages.hh>
#include <string>

namespace libwebots
{
namespace plugin
{
namespace modules
{
namespace messages
{
namespace builders
{
	class Snap
	{
		public:
			static communication::Message Plane(std::string const &body,
			                                    double             point[3],
			                                    double             normal[3],
			                                    double             margin = 0,
			                                    bool               closestchild = true);

			static communication::Message Plane(std::string const &body,
			                                    double             p1,
			                                    double             p2,
			                                    double             p3,
			                                    double             n1,
			                                    double             n2,
			                                    double             n3,
			                                    double             margin = 0,
			                                    bool               closestchild = true);
	};
}
}
}
}
}

#endif /* __LIBWEBOTS_PLUGIN_MODULES_MESSAGES_BUILDERS_SNAP_H__ */

