/**
 * \file physicsmodule.hh
 *
 *  \date Mar 8, 2011
 *  \author Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_PHYSICSMODULE_HH_
#define __LIBWEBOTS_PLUGIN_PHYSICSMODULE_HH_


#include <libwebots/plugin/module.hh>
#include <libwebots/plugin/webotsinterface.hh>
#include <vector>

namespace libwebots
{
namespace plugin
{
	class PhysicsModule : public Module,
	                      public WebotsInterface
	{
		public :
			typedef std::vector<PhysicsModule *> List;

			PhysicsModule(dWorldID world,
			              dSpaceID space,
			              dJointGroupID jointGroup,
			              Module::MapByTypeID const &dependencies);
			virtual ~PhysicsModule();
	};
}
}


#endif //__LIBWEBOTS_PLUGIN_PHYSICSMODULE_HH_

