#ifndef __LIBWEBOTS_PLUGIN_UTILS_H__
#define __LIBWEBOTS_PLUGIN_UTILS_H__

#include <libwebots/plugin/body.hh>
#include <plugins/physics.h>
#include <vector>
#include <string>
#include <map>
#include <memory>

namespace libwebots
{
namespace plugin
{
	class Utils
	{
		public:
			static dJointID FindWebotsJoint(dBodyID body, dBodyID &parent, dVector3 axis);
			static dJointID FindWebotsJoint(dBodyID body, dVector3 axis);
			static dJointID FindWebotsJoint(dBodyID body, dBodyID &parent);
			static dJointID FindWebotsJoint(dBodyID body);

			static std::vector<dBodyID> AllBodies(dBodyID origin);
			static std::vector<dJointID> AllJoints(dBodyID origin);
		private:
			static void AllBodies(dBodyID body, dBodyID origin, std::vector<dBodyID> &bodies);
			static void AllJoints(dBodyID body, dBodyID origin, std::vector<dJointID> &joints);
	};
}
}

#endif /* __LIBWEBOTS_PLUGIN_UTILS_H__ */

