#include <libwebots/plugin/definitions.h>
#include <libwebots/plugin/plugin.hh>

using namespace libwebots::plugin;

void
webots_physics_init(dWorldID world, dSpaceID space, dJointGroupID joint_group)
{
	Plugin::Initialize(world, space, joint_group);

	webots_plugin_register_modules();
}

void
webots_physics_step()
{
	Plugin::Instance().Step();
}

void
webots_physics_step_end()
{
	Plugin::Instance().StepEnd();
}

int
webots_physics_collide(dGeomID g1, dGeomID g2)
{
	if (Plugin::Instance().Collide(g1, g2))
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

void
webots_physics_draw()
{
	Plugin::Instance().Draw();
}

void
webots_physics_predraw()
{
	Plugin::Instance().PreDraw();
}

void
webots_physics_cleanup()
{
	Plugin::Finalize();
}


/**
 * \mainpage
 * libwebots is a library to generate generic webots generic plugin, based on a
 * modular, plug-amd-play architecture.
 *
 * The framework is based on libwebots-communication, which provides an inter
 * process communication based on google protocol buffers.
 *
 * libwebots-messages is a library that provides the protocul buffer messages
 * that should be used between the webots controller/supervisor process and the
 * physics plugins. This is the user API of the framework.
 *
 * libwebots-plugins are the plugin based on ODE/Webots interface.
 */
