/**
 * \file webotsinterface.hh
 *
 *  \date Mar 7, 2011
 *  \author Alexandre Tuleu
 */

#ifndef __LIBWEBOTS_PLUGIN_WEBOTSINTERFACE_HH_
#define __LIBWEBOTS_PLUGIN_WEBOTSINTERFACE_HH_

#include <plugins/physics.h>

namespace libwebots
{
namespace plugin
{
	class WebotsInterface
	{
		dWorldID d_world;
		dSpaceID d_space;
		dJointGroupID d_jointGroup;

		public:
			WebotsInterface(dWorldID world, dSpaceID space, dJointGroupID jointGroup);

			virtual ~WebotsInterface();
			virtual void Step();
			virtual void StepEnd();

			virtual bool Collide(dGeomID g1, dGeomID g2);

			virtual void PreDraw();
			virtual void Draw();

			dWorldID World() const;
			dSpaceID Space() const;
			dJointGroupID JointGroup() const;
	};
}
}


#endif // __LIBWEBOTS_PLUGIN_WEBOTSINTERFACE_HH_
