#include "errorcollector.hh"

using namespace libwebots::tools::protodoc;
using namespace std;

ErrorCollector::Error::Error(int line,
                             int column,
                             string const &message)
:
	Line(line),
	Column(column),
	Message(message)
{
}

void
ErrorCollector::AddError(int line,
                         int column,
                         string const &message)
{
	d_errors.push_back(Error(line, column, message));
}

ErrorCollector::iterator
ErrorCollector::begin()
{
	return d_errors.begin();
}

ErrorCollector::iterator
ErrorCollector::end()
{
	return d_errors.end();
}

ErrorCollector::const_iterator
ErrorCollector::begin() const
{
	return d_errors.begin();
}

ErrorCollector::const_iterator
ErrorCollector::end() const
{
	return d_errors.end();
}
