#ifndef __LIBWEBOTS_TOOLS_PROTODOC_ERROR_COLLECTOR_H__
#define __LIBWEBOTS_TOOLS_PROTODOC_ERROR_COLLECTOR_H__

#include <google/protobuf/io/tokenizer.h>
#include <vector>
#include <string>

namespace libwebots
{
namespace tools
{
namespace protodoc
{
	class ErrorCollector : public google::protobuf::io::ErrorCollector
	{
		public:
			struct Error
			{
				int Line;
				int Column;
				std::string Message;

				Error(int line,
				      int column,
				      std::string const &message);
			};

			typedef std::vector<Error> Container;
			typedef Container::iterator iterator;
			typedef Container::const_iterator const_iterator;

			virtual void AddError(int line,
			                      int column,
			                      std::string const &message);

			iterator begin();
			iterator end();

			const_iterator begin() const;
			const_iterator end() const;
		private:
			Container d_errors;
	};
}
}
}

#endif /* __LIBWEBOTS_TOOLS_PROTODOC_ERROR_COLLECTOR_H__ */
