#include "importerrors.hh"

using namespace libwebots::tools::protodoc;
using namespace std;

ImportErrors::Error::Error(string const &filename,
                           int line,
                           int column,
                           string const &message)
:
	Filename(filename),
	Line(line),
	Column(column),
	Message(message)
{
}

void
ImportErrors::AddError(string const &filename,
                       int line,
                       int column,
                       string const &message)
{
	d_errors.push_back(Error(filename, line, column, message));
}

ImportErrors::iterator
ImportErrors::begin()
{
	return d_errors.begin();
}

ImportErrors::iterator
ImportErrors::end()
{
	return d_errors.end();
}

ImportErrors::const_iterator
ImportErrors::begin() const
{
	return d_errors.begin();
}

ImportErrors::const_iterator
ImportErrors::end() const
{
	return d_errors.end();
}
