#ifndef __LIBWEBOTS_TOOLS_PROTODOC_IMPORT_ERRORS_H__
#define __LIBWEBOTS_TOOLS_PROTODOC_IMPORT_ERRORS_H__

#include <google/protobuf/compiler/importer.h>
#include <vector>
#include <string>

namespace libwebots
{
namespace tools
{
namespace protodoc
{
	class ImportErrors : public google::protobuf::compiler::MultiFileErrorCollector
	{
		public:
			struct Error
			{
				std::string Filename;
				int Line;
				int Column;
				std::string Message;

				Error(std::string const &filename,
				      int line,
				      int column,
				      std::string const &message);
			};

			typedef std::vector<Error> Container;
			typedef Container::iterator iterator;
			typedef Container::const_iterator const_iterator;

			virtual void AddError(std::string  const &filename,
			                      int line,
			                      int column,
			                      std::string const &message);

			iterator begin();
			iterator end();

			const_iterator begin() const;
			const_iterator end() const;
		private:
			Container d_errors;
	};
}
}
}

#endif /* __LIBWEBOTS_TOOLS_PROTODOC_IMPORT_ERRORS_H__ */
