#include "indentstream.hh"

#include <iostream>

using namespace libwebots::tools::protodoc;
using namespace std;

IndentStream::IndentStream(ostream &stream)
:
	ostream(this),
	d_stream(stream),
	d_level(0),
	d_indentNext(false)
{
}

void
IndentStream::Indent()
{
	++d_level;
}

void
IndentStream::Unindent()
{
	if (d_level > 0)
	{
		--d_level;
	}
}

int
IndentStream::overflow(int c)
{
	if (c == '\n')
	{
		d_indentNext = true;
	}
	else if (d_indentNext)
	{
		d_indentNext = false;

		d_stream << string(d_level, '\t');
		d_stream.flush();
	}

	d_stream.rdbuf()->sputc(c);

	return c;
}
