#ifndef __LIBWEBOTS_TOOLS_PROTODOC_INDENT_STREAM_H__
#define __LIBWEBOTS_TOOLS_PROTODOC_INDENT_STREAM_H__

#include <ostream>
#include <sstream>

namespace libwebots
{
namespace tools
{
namespace protodoc
{
	class IndentStream : public std::streambuf, public std::ostream
	{
		std::ostream &d_stream;
		size_t d_level;
		bool d_indentNext;

		public:
			IndentStream(std::ostream &stream);

			void Indent();
			void Unindent();
		protected:
			virtual int overflow(int c);
	};
}
}
}

#endif /* __LIBWEBOTS_TOOLS_PROTODOC_INDENT_STREAM_H__ */

