#ifndef __LIBWEBOTS_TOOLS_PROTODOC_UTILS_H__
#define __LIBWEBOTS_TOOLS_PROTODOC_UTILS_H__

#include <vector>
#include <string>

namespace libwebots
{
namespace tools
{
namespace protodoc
{
	class Utils
	{
		public:
			static std::vector<std::string> Split(std::string const &str,
			                                      std::string const &delimiter,
			                                      size_t mmax = 0,
			                                      bool includeEmpty = true);

			static std::string Join(std::vector<std::string> const &lines,
			                        std::string const &delimiter);

			static std::string StripLeft(std::string const &s,
			                             std::string const &stripped = "\r\n ");

			static std::string StripRight(std::string const &s,
			                              std::string const &stripped = "\r\n ");

			static std::string Strip(std::string const &s,
			                         std::string const &stripped = "\r\n ");

			static bool EndsWith(std::string const &s,
			                     std::string const &other);

			static bool StartsWith(std::string const &s,
			                       std::string const &other);

			static bool MakeDirs(std::string const &path);
			static std::string Dirname(std::string const &path);
			static std::string Basename(std::string const &path);
			static std::string Realpath(std::string const &path);

			static std::string Replace(std::string const &s,
			                           std::string const &find,
			                           std::string const &repl);
	};
}
}
}

#endif /* __LIBWEBOTS_TOOLS_PROTODOC_UTILS_H__ */

